package com.sckj.project.service.task;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.building.LargeBuilding;
import com.sckj.project.domain.building.LargeBuildingControl;
import com.sckj.project.domain.building.LargeBuildingControlAmmeterDetail;
import com.sckj.project.domain.building.LargeBuildingControlLoadDetail;
import com.sckj.project.service.building.ILargePlatBuildingAmmeterDetailService;
import com.sckj.project.service.building.ILargePlatBuildingControlService;
import com.sckj.project.service.building.ILargePlatBuildingLoadDetailService;
import com.sckj.project.service.building.ILargePlatBuildingService;
import com.sckj.project.util.HttpRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class BuildingTaskService {

    @Autowired
    private ILargePlatBuildingService largePlatBuildingService;

    @Autowired
    private ILargePlatBuildingControlService largePlatBuildingControlService;

    @Autowired
    private ILargePlatBuildingAmmeterDetailService largePlatBuildingAmmeterDetailService;

    @Autowired
    private ILargePlatBuildingLoadDetailService largePlatBuildingLoadDetailService;

    @Autowired
    private HttpRequestUtil httpRequestUtil;


    public void myTask(){

        /*楼宇表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getBuildingUrl());
            if (Objects.nonNull(array)){
                List<LargeBuilding> list = array.toList(LargeBuilding.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatBuildingService.remove(new LambdaQueryWrapper<>());
                    largePlatBuildingService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*楼宇中控*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getBuildingControlUrl());
            if (Objects.nonNull(array)){
                List<LargeBuildingControl> list = array.toList(LargeBuildingControl.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatBuildingControlService.remove(new LambdaQueryWrapper<>());
                    largePlatBuildingControlService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*楼宇中控电表明细表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getBuildingAmmeterDetailUrl());
            if (Objects.nonNull(array)){
                List<LargeBuildingControlAmmeterDetail> list = array.toList(LargeBuildingControlAmmeterDetail.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatBuildingAmmeterDetailService.remove(new LambdaQueryWrapper<>());
                    largePlatBuildingAmmeterDetailService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*楼宇中控负载明细表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getBuildingLoadDetailUrl());
            if (Objects.nonNull(array)){
                List<LargeBuildingControlLoadDetail> list = array.toList(LargeBuildingControlLoadDetail.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatBuildingLoadDetailService.remove(new LambdaQueryWrapper<>());
                    largePlatBuildingLoadDetailService.saveBatch(list);
                }
            }

        } catch (Exception e) {
            log.error(e.getMessage());
        }

    }
}
