package com.sckj.project.service.task;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.engineering.LargeCamera;
import com.sckj.project.domain.engineering.LargeIssue;
import com.sckj.project.domain.engineering.LargeProject;
import com.sckj.project.service.engineering.ILargeCameraService;
import com.sckj.project.service.engineering.ILargePlatIssueService;
import com.sckj.project.service.engineering.ILargePlatProjectService;
import com.sckj.project.util.HttpRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class EngineeringTaskService {

    @Autowired
    private ILargeCameraService largeCameraService;

    @Autowired
    private ILargePlatIssueService largePlatIssueService;

    @Autowired
    private ILargePlatProjectService largePlatProjectService;

    @Autowired
    private HttpRequestUtil httpRequestUtil;


    public void myTask(){

        /*监控表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getEngineerCameraUrl());
            if (Objects.nonNull(array)){
                List<LargeCamera> list = array.toList(LargeCamera.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largeCameraService.remove(new LambdaQueryWrapper<>());
                    largeCameraService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*上报问题表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getEngineerIssueUrl());
            if (Objects.nonNull(array)){
                List<LargeIssue> list = array.toList(LargeIssue.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatIssueService.remove(new LambdaQueryWrapper<>());
                    largePlatIssueService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*项目表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getEngineerProjectUrl());
            if (Objects.nonNull(array)){
                List<LargeProject> list = array.toList(LargeProject.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatProjectService.remove(new LambdaQueryWrapper<>());
                    largePlatProjectService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

    }
}
