package com.sckj.project.service.task;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.logistics.LargeBuildingAssetDirs;
import com.sckj.project.domain.logistics.LargeHousingLand;
import com.sckj.project.domain.logistics.LargeOfficeAssetDirs;
import com.sckj.project.domain.logistics.LargeServiceAssetDirs;
import com.sckj.project.service.logistics.*;
import com.sckj.project.util.HttpRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class LogisticsTaskService {

    @Autowired
    private ILargePlatHousingLandService largePlatHousingLandService;

    @Autowired
    private ILargePlatLogisticsService largePlatLogisticsService;

    @Autowired
    private ILargePlatLogisticsBuildingAssetService largePlatLogisticsBuildingAssetService;

    @Autowired
    private ILargePlatLogisticsOfficeAssetService largePlatLogisticsOfficeAssetService;

    @Autowired
    private ILargePlatLogisticsServiceAssetService largePlatLogisticsServiceAssetService;

    @Autowired
    private HttpRequestUtil httpRequestUtil;



    public void myTask(){

        /*房产土地表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsHousingUrl());
            if (Objects.nonNull(array)){
                List<LargeHousingLand> list = array.toList(LargeHousingLand.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatHousingLandService.remove(new LambdaQueryWrapper<>());
                    largePlatHousingLandService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*后勤运行监控中心表*/
        largePlatLogisticsService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsUrl()));

        /*楼宇设备表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsBuildingAssetUrl());
            if ( Objects.nonNull(array)){
                List<LargeBuildingAssetDirs> list = array.toList(LargeBuildingAssetDirs.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatLogisticsBuildingAssetService.remove(new LambdaQueryWrapper<>());
                    largePlatLogisticsBuildingAssetService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*办公资产表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsOfficeAssetUrl());
            if ( Objects.nonNull(array)){
                List<LargeOfficeAssetDirs> list = array.toList(LargeOfficeAssetDirs.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatLogisticsOfficeAssetService.remove(new LambdaQueryWrapper<>());
                    largePlatLogisticsOfficeAssetService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*服务设备表*/
        try {
            JSONArray array = httpRequestUtil.callExternalApi(ApiUrlConfig.getLogisticsServiceAssetUrl());
            if (Objects.nonNull(array)){
                List<LargeServiceAssetDirs> list = array.toList(LargeServiceAssetDirs.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatLogisticsServiceAssetService.remove(new LambdaQueryWrapper<>());
                    largePlatLogisticsServiceAssetService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

    }
}
