package com.sckj.project.service.task;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.service.*;
import com.sckj.project.service.service.*;
import com.sckj.project.util.HttpRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class ServiceTaskService {

    @Autowired
    private ILargePlatAccessService largePlatAccessService;

    @Autowired
    private ILargePlatBasicsService largePlatBasicsService;

    @Autowired
    private ILargePlatBasicsCompanyService largePlatBasicsCompanyService;

    @Autowired
    private ILargePlatBasicsServerService largePlatBasicsServerService;

    @Autowired
    private ILargePlatBasicsSystemService largePlatBasicsSystemService;

    @Autowired
    private ILargePlatEmployeeHealthService largePlatEmployeeHealthService;

    @Autowired
    private ILargePlatEmployeeHealthIllnessService largePlatEmployeeHealthIllnessService;

    @Autowired
    private ILargePlatEmployeeTypeService largePlatEmployeeTypeService;

    @Autowired
    private ILargePlatEmployeeTypeFlowService largePlatEmployeeTypeFlowService;

    @Autowired
    private ILargePlatGreenFoodsService largePlatGreenFoodsService;

    @Autowired
    private ILargePlatGreenSmartService largePlatGreenSmartService;

    @Autowired
    private ILargePlatGreenSmartOtherService largePlatGreenSmartOtherService;

    @Autowired
    private ILargePlatGreenSmartRankService largePlatGreenSmartRankService;

    @Autowired
    private ILargePlatGreenSmartSafetyService largePlatGreenSmartSafetyService;

    @Autowired
    private ILargePlatPostStationService largePlatPostStationService;

    @Autowired
    private ILargePlatPostStationChartService largePlatPostStationChartService;

    @Autowired
    private ILargePlatPropertyService largePlatPropertyService;

    @Autowired
    private ILargePlatPropertyListService largePlatPropertyListService;

    @Autowired
    private ILargePlatPropertyToolsService largePlatPropertyToolsService;

    @Autowired
    private HttpRequestUtil httpRequestUtil;

    public void myTask(){

        /*便捷出入*/
        JSONArray accArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getAccessUrl());
        if (Objects.nonNull(accArray)){
            largePlatAccessService.saveOrUpdate(accArray);
        }


        /*基础运行数据*/
        JSONArray basicArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getBasicsApiUrl());
        if (Objects.nonNull(basicArray)){
            largePlatBasicsService.saveOrUpdate(basicArray);
        }


        /*公司活跃人数*/
        JSONArray compArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getBasicsCompanyUrl());
        if (Objects.nonNull(compArray)){
            largePlatBasicsCompanyService.saveOrUpdate(compArray);
        }


        /*服务信息*/
        JSONArray serverArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getBasicsServerUrl());
        if (Objects.nonNull(serverArray)){
            largePlatBasicsServerService.saveOrUpdate(serverArray);
        }

        /*系统运行峰值情况分析*/
        try {
            JSONArray sysArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getBasicsSystemUrl());
            if (Objects.nonNull(sysArray)){
                List<PlatBasicsSystem> list = sysArray.toList(PlatBasicsSystem.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatBasicsSystemService.remove(new LambdaQueryWrapper<>());
                    largePlatBasicsSystemService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*员工健康*/
        largePlatEmployeeHealthService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getHealthUrl()));

        /*多发疾病排行*/
        try {
            JSONArray helthArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getHealthIllnessUrl());
            if (Objects.nonNull(helthArray)){
                List<PlatEmployeeHealthIllness> list = helthArray.toList(PlatEmployeeHealthIllness.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatEmployeeHealthIllnessService.remove(new LambdaQueryWrapper<>());
                    largePlatEmployeeHealthIllnessService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*员工概况*/
        largePlatEmployeeTypeService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getEmployeeTypeUrl()));

        /*近一周人流量统计*/
        try {
            JSONArray employeeArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getEmployeeTypeFlowUrl());
            if ( Objects.nonNull(employeeArray)){
                List<PlatEmployeeTypeFlow> list = employeeArray.toList(PlatEmployeeTypeFlow.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatEmployeeTypeFlowService.remove(new LambdaQueryWrapper<>());
                    largePlatEmployeeTypeFlowService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*菜谱数据*/
        largePlatGreenFoodsService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getGreenFoodsUrl()));

        /*绿智食堂*/
        largePlatGreenSmartService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getGreenSmartUrl()));

        /*绿智食堂 其他参数*/
        largePlatGreenSmartOtherService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getGreenSmartOtherUrl()));

        /*绿智食堂 排名*/
        try {
            JSONArray smartArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getGreenSmartRankUrl());
            if (Objects.nonNull(smartArray)){
                List<PlatGreenSmartRank> list = smartArray.toList(PlatGreenSmartRank.class);
                if ( CollectionUtil.isNotEmpty(list)){
                    largePlatGreenSmartRankService.remove(new LambdaQueryWrapper<>());
                    largePlatGreenSmartRankService.saveBatch(list);
                }
            }

        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*食堂安全管理*/
        largePlatGreenSmartSafetyService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getGreenSmartSafetyUrl()));

        /*物业服务*/
        largePlatPostStationService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getPostStationUrl()));

        /*近六个月报修分类占比*/
        try {
            JSONArray stationArray = httpRequestUtil.callExternalApi(ApiUrlConfig.getPostStationChartUrl());
            if ( Objects.nonNull(stationArray)){
                List<PlatPostStationChart> list = stationArray.toList(PlatPostStationChart.class);
                if (CollectionUtil.isNotEmpty(list)){
                    largePlatPostStationChartService.remove(new LambdaQueryWrapper<>());
                    largePlatPostStationChartService.saveBatch(list);
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        /*共享驿站*/
        largePlatPropertyService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getPropertyUrl()));

        /*驿站列表*/
        largePlatPropertyListService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getPropertyListUrl()));

        /*工具表列表*/
        largePlatPropertyToolsService.saveOrUpdate(httpRequestUtil.callExternalApi(ApiUrlConfig.getPropertyToolsUrl()));

    }

}
