package com.sckj.project.task;

import com.sckj.project.service.task.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * @Description
 * @Author bqyang
 * @Date 2025/3/4 15:02
 * @Version 1.0
 */
@Slf4j
@Component
public class ProjectTaskController {

    @Autowired
    private ServiceTaskService serviceTaskService;
    @Autowired
    private LogisticsTaskService logisticsTaskService;
    @Autowired
    private BuildingTaskService buildingTaskService;
    @Autowired
    private EngineeringTaskService engineeringTaskService;
    @Autowired
    private CarTaskService carTaskService;


    /**
     *  服务保障中心
     */
    @Scheduled(cron = "0 0/20 6-19 * * ?")
    public void taskService() {
        log.info("服务保障中心定时任务开始执行");
        serviceTaskService.myTask();
        log.info("服务保障中心定时任务开始执行完成");
    }


    /**
     *  后勤资源监控
     */
    @Scheduled(cron = "0 0/22 06-19 * * ?")
    public void taskLogistics(){
        log.info("后勤资源监控定时任务开始执行");
        logisticsTaskService.myTask();
        log.info("后勤资源监控定时任务开始执行完成");
    }


    /**
     *  楼宇运行监控
     */
    @Scheduled(cron = "0 0/24 06-19 * * ?")
    public void taskBuilding(){
        log.info("楼宇运行监控定时任务开始执行");
        buildingTaskService.myTask();
        log.info("楼宇运行监控定时任务开始执行完成");
    }

    /**
     *  工程现场监控
     */
    @Scheduled(cron = "0 0/26 06-19 * * ?")
    public void taskEngineering(){
        log.info("工程现场监控定时任务开始执行");
        engineeringTaskService.myTask();
        log.info("工程现场监控定时任务开始执行完成");
    }

    /**
     *  公务用车
     */
    @Scheduled(cron = "0 0/30 06-19 * * ?")
    public void taskCar(){
        log.info("公务用车定时任务开始执行");
        carTaskService.myTask();
        log.info("公务用车定时任务开始执行完成");
    }
}
