package com.sckj.project.util;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.sckj.project.constants.Constants;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

/**
 * @Description
 * @Author bqyang
 * @Date 2025/3/7 11:33
 * @Version 1.0
 */
@Slf4j
@Component
public class HttpRequestUtil {

    @Autowired
    private RestTemplate restTemplate;

    /**
     * 发送GET请求
     */
    public JSONArray callExternalApi(String url) {
        try {
            HttpHeaders headers = new HttpHeaders();
            headers.set(Constants.REQUEST_HEAD, AESUtil.encrypt(Constants.REQUEST_HEAD_SCR));
            HttpEntity<String> entity = new HttpEntity<>(null, headers);
            ResponseEntity<String> response = restTemplate.exchange(url, HttpMethod.GET, entity, String.class);
            if (StringUtils.isEmpty(response.getBody()) || !response.getStatusCode().is2xxSuccessful()){
                return null;
            }
            return JSONUtil.parseObj(response.getBody()).getJSONArray("data");
        } catch (Exception e) {
            log.error("网络请求出现异常：{}", e.getMessage());
            return null;
        }
    }

}
